//+------------------------------------------------------------------+
//|                                                        EA_MA.mq4 |
//|                                                   VMQL Solutions |
//|                                               http://www.vmql.ru |
//+------------------------------------------------------------------+
#property copyright "VMQL Solutions"
#property link      "http://www.vmql.ru"

extern string EA_1 = " EA 1";
extern bool Close_bars = true;
extern int TP = 0;
extern int SL = 0;
extern int TS = 0;
extern double Lot = 0.1;
extern bool Close_reverse = true;
extern double Ras_to_open = 10;
extern int Max_orders = 10;
extern int Slippage = 10;
extern bool MarketExecution = true;
int number_try = 20;
int time_period_try = 1;
extern int ID = 3285689756;
extern string MA_1 = " MA 1";
extern int MA_1_period = 12;
extern int MA_1_shift = 0;
extern int MA_1_method = 0;
extern int MA_1_applied_price = 0;
extern string MA_2 = " MA 2";
extern int MA_2_period = 35;
extern int MA_2_shift = 0;
extern int MA_2_method = 0;
extern int MA_2_applied_price = 0;

int BAR;
string main_id;
int init()
{  
   main_id = "@" + DoubleToStr(ID,0) + "@";
   if ( !GlobalVariableCheck(main_id + "GLOB_START") )GlobalVariableSet(main_id + "GLOB_START", TimeCurrent());
   
   if ( Close_bars )BAR = 1;
   else BAR = 0;
   
   return(0);
}

int deinit()
{
   switch( UninitializeReason() )
   {
      case (REASON_REMOVE || REASON_CHARTCLOSE): delete_glob ( main_id );
   }
   if ( IsTesting() )delete_glob ( main_id );
   return(0);
}

int start()
{
   if ( TS != 0 )modify_orders();
   
   int ma_1_add = 0;
   int ma_2_add = 0;
   
   if ( MA_1_shift < 0 )ma_1_add = MathAbs(MA_1_shift);
   if ( MA_2_shift < 0 )ma_2_add = MathAbs(MA_2_shift);

   double ma_1_1 = NormalizeDouble(iMA(NULL, 0, MA_1_period, MA_1_shift, MA_1_method, MA_1_applied_price, BAR + ma_1_add), Digits);
   double ma_1_2 = NormalizeDouble(iMA(NULL, 0, MA_1_period, MA_1_shift, MA_1_method, MA_1_applied_price, BAR + 1 + ma_1_add), Digits);
   double ma_2_1 = NormalizeDouble(iMA(NULL, 0, MA_2_period, MA_2_shift, MA_2_method, MA_2_applied_price, BAR + ma_2_add), Digits);
   double ma_2_2 = NormalizeDouble(iMA(NULL, 0, MA_2_period, MA_2_shift, MA_2_method, MA_2_applied_price, BAR + 1 + ma_2_add), Digits);
   
   if ( ma_2_1 < ma_1_1 )
   {
      if ( Close_reverse )close_all(OP_SELL);
      if ( order_total() < Max_orders && NormalizeDouble((ma_1_1 - ma_2_1)/Point,0) >= Ras_to_open && last_signal(OP_BUY) )open( OP_BUY, Lot, SL, TP);
   }
   
   if ( ma_2_1 > ma_1_1 )
   {
      if ( Close_reverse )close_all(OP_BUY);
      if ( order_total() < Max_orders && NormalizeDouble((ma_2_1 - ma_1_1)/Point,0) >= Ras_to_open && last_signal(OP_SELL) )open( OP_SELL, Lot, SL, TP);
   }
   
   return(0);
}

bool last_signal ( int type )
{
   bool res = false;
   int i;
   int ma_1_add = 0;
   int ma_2_add = 0;
   
   if ( MA_1_shift < 0 )ma_1_add = MathAbs(MA_1_shift);
   if ( MA_2_shift < 0 )ma_2_add = MathAbs(MA_2_shift);
   
   double ma_1, ma_2;
   datetime time = 0;
   
   for( i = OrdersTotal() - 1; i >= 0; i -- )
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);      
      if( OrderOpenTime() > time && OrderMagicNumber() == ID && OrderType() == type )time = OrderOpenTime();
   }
   
   if ( time == 0 )
   for( i = OrdersHistoryTotal() - 1; i >= 0; i-- )
   {
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);      
      if( OrderOpenTime() > time && OrderMagicNumber() == ID && OrderType() == type )time = OrderOpenTime();
   }
   
   if ( time == 0 )return(true);
   else
   {
      for ( i = iBarShift(NULL,0,time); i >= BAR; i -- )
      {
         ma_1 = NormalizeDouble(iMA(NULL, 0, MA_1_period, MA_1_shift, MA_1_method, MA_1_applied_price, i + ma_1_add),Digits);
         ma_2 = NormalizeDouble(iMA(NULL, 0, MA_2_period, MA_2_shift, MA_2_method, MA_2_applied_price, i + ma_2_add),Digits);
      
         if ( (ma_2 < ma_1 && type == OP_SELL) || (ma_2 > ma_1 && type == OP_BUY) )
         {
            res = true;
            break;
         }
      }
   }
   
   return(res);
}

void delete_glob ( string c )
{
   int i;
   for ( i = GlobalVariablesTotal()-1; i>= 0 ; i-- )if ( StringFind(GlobalVariableName(i),c) >= 0 )GlobalVariableDel(GlobalVariableName(i));
}

int order_total( int type_1 = -1, int type_2 = -1 )
{
   int i;
   int kol = 0;
   for( i = OrdersTotal() - 1; i >= 0; i -- )       
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if( OrderMagicNumber() == ID && (OrderType() == type_1 || OrderType() == type_2) )kol++;
      if( OrderMagicNumber() == ID && type_1 == -1 && type_2 == -1 )kol++;
   }
   return(kol);   
}

void modify_orders()
{
   int i;
   for( i = OrdersTotal() - 1; i >= 0; i-- )
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if( OrderMagicNumber() != ID )continue;
      
      if( OrderType() == OP_BUY )
      {
         if ( OrderStopLoss() == 0 && (Ask-OrderOpenPrice())/Point >= TS && NormalizeDouble(OrderStopLoss(),Digits) != NormalizeDouble(OrderOpenPrice(),Digits) )OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);
         if ( OrderStopLoss() != 0 && (Ask - TS * Point) > OrderStopLoss() && NormalizeDouble(OrderStopLoss(),Digits) != NormalizeDouble(Ask - TS * Point,Digits) )OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask - TS * Point,Digits),OrderTakeProfit(),0);
      }
      
      if( OrderType() == OP_SELL )
      {
         if ( OrderStopLoss() == 0 && (OrderOpenPrice()-Bid)/Point >= TS && NormalizeDouble(OrderStopLoss(),Digits) != NormalizeDouble(OrderOpenPrice(),Digits)  )OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);
         if ( OrderStopLoss() != 0 && (Bid + TS * Point) < OrderStopLoss() && NormalizeDouble(OrderStopLoss(),Digits) != NormalizeDouble(Bid + TS * Point,Digits) )OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid + TS * Point,Digits),OrderTakeProfit(),0); 
      }
   }   
}

double check_lot(double &lo)
{
   double l = MarketInfo(Symbol(),MODE_LOTSTEP);
   int ok = 0;
   while ( l < 1 ){l*=10;ok++;}
   if( lo < MarketInfo(Symbol(),MODE_MINLOT) )lo = MarketInfo(Symbol(),MODE_MINLOT);
   if( lo > MarketInfo(Symbol(),MODE_MAXLOT) )lo = MarketInfo(Symbol(),MODE_MAXLOT);
   return(NormalizeDouble(lo,ok));
}

int open( int type, double l, double sl = 0, double tp = 0, string comm = "")
{
   bool res;
   int isOpened = 0, try = 0;
   double s,t;
   color color_order;
   
   while ( IsTradeContextBusy() )Sleep(500);
   RefreshRates();
   if ( sl != 0 && sl < MarketInfo(Symbol(),MODE_STOPLEVEL) )sl = MarketInfo(Symbol(),MODE_STOPLEVEL);
   if ( tp != 0 && tp < MarketInfo(Symbol(),MODE_STOPLEVEL) )tp = MarketInfo(Symbol(),MODE_STOPLEVEL);
   if ( type == 0 )
   {
      if ( tp == 0 )t = 0;
      if ( tp != 0 )t = Ask + tp * Point;
      if ( sl == 0 )s = 0;
      if ( sl != 0 )s = Ask - sl * Point;
   }
   if ( type == 1 )
   {
      if ( tp == 0 )t = 0;
      if ( tp != 0 )t = Bid - tp * Point;
      if ( sl == 0 )s = 0;
      if ( sl != 0 )s = Bid + sl * Point;
   }
   
   s = NormalizeDouble(s,Digits);
   t = NormalizeDouble(t,Digits);
   
   if ( MarketExecution )
   {
      if(type == 0)isOpened = OrderSend(Symbol(),type,check_lot(l),NormalizeDouble(Ask,Digits),Slippage,0,0,comm,ID);
      if(type == 1)isOpened = OrderSend(Symbol(),type,check_lot(l),NormalizeDouble(Bid,Digits),Slippage,0,0,comm,ID);
   }
   else
   {
      if(type == 0)isOpened = OrderSend(Symbol(),type,check_lot(l),NormalizeDouble(Ask,Digits),Slippage,s,t,comm,ID);
      if(type == 1)isOpened = OrderSend(Symbol(),type,check_lot(l),NormalizeDouble(Bid,Digits),Slippage,s,t,comm,ID);
   }
   
   while( isOpened < 0 )
   {
      Sleep(time_period_try * 1000);
      while ( IsTradeContextBusy() )Sleep(500);
      RefreshRates();
      if ( type == 0 )
      {
         if ( tp == 0 )t = 0;
         if ( tp != 0 )t = Ask + tp * Point;
         if ( sl == 0 )s = 0;
         if ( sl != 0 )s = Ask - sl * Point;
      }
      if ( type == 1 )
      {
         if ( tp == 0 )t = 0;
         if ( tp != 0 )t = Bid - tp * Point;
         if ( sl == 0 )s = 0;
         if ( sl != 0 )s = Bid + sl * Point;
      }
      s = NormalizeDouble(s,Digits);
      t = NormalizeDouble(t,Digits);
      try++;
      if ( MarketExecution )
      {
         if(type == 0)isOpened = OrderSend(Symbol(),type,check_lot(l),NormalizeDouble(Ask,Digits),Slippage,0,0,comm,ID);
         if(type == 1)isOpened = OrderSend(Symbol(),type,check_lot(l),NormalizeDouble(Bid,Digits),Slippage,0,0,comm,ID);
      }
      else
      {
         if(type == 0)isOpened = OrderSend(Symbol(),type,check_lot(l),NormalizeDouble(Ask,Digits),Slippage,s,t,comm,ID);
         if(type == 1)isOpened = OrderSend(Symbol(),type,check_lot(l),NormalizeDouble(Bid,Digits),Slippage,s,t,comm,ID);
      }
      if(try > number_try || isOpened >= 0) break;
   }
   
   if( isOpened < 0 ) Print("  ,  :", GetLastError());
   else if ( MarketExecution )
   {
      OrderSelect(isOpened,SELECT_BY_TICKET);
      if ( OrderType() == 0 )color_order = Blue;
      if ( OrderType() == 1 )color_order = Red;
      try = 0;
      
      if ( NormalizeDouble(OrderStopLoss(),Digits) != NormalizeDouble(s,Digits) || NormalizeDouble(OrderTakeProfit(),Digits) != NormalizeDouble(t,Digits) )
      {
         while ( IsTradeContextBusy() )Sleep(500);
         res = OrderModify(OrderTicket(),OrderOpenPrice(),s,t,0,color_order);
         while ( !res )
         {
            while ( IsTradeContextBusy() )Sleep(500);
            res = OrderModify(OrderTicket(),OrderOpenPrice(),s,t,0,color_order);
            Sleep(time_period_try * 1000);
            try ++;
            Print("   " + DoubleToStr(OrderType(),0) + "   " + DoubleToStr(OrderOpenPrice(),Digits) + "    OPEN,  " + DoubleToStr(try,0));
            if ( try > number_try || res )break;
         }
      }
   }
   return (isOpened);
}

bool close(int ticket)
{
   bool isClosed = false;
   int try = 0;
   while ( IsTradeContextBusy() )Sleep(500);
   RefreshRates();
   isClosed = OrderSelect(ticket,SELECT_BY_TICKET);
   if ( !isClosed )return(false);
   if ( OrderType() < 2 )isClosed = OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(OrderClosePrice(),MarketInfo(OrderSymbol(),MODE_DIGITS)), Slippage, 0);
   if ( OrderType() > 1 )isClosed = OrderDelete(OrderTicket());
   while(!isClosed)
   {
      Sleep(time_period_try * 1000);
      while ( IsTradeContextBusy() )Sleep(500);
      RefreshRates();
      try ++;
      if ( OrderType() < 2 )isClosed = OrderClose(OrderTicket(), OrderLots(),NormalizeDouble(OrderClosePrice(),MarketInfo(OrderSymbol(),MODE_DIGITS)), Slippage, 0);
      if ( OrderType() > 1 )isClosed = OrderDelete(OrderTicket());
      if(try > number_try || isClosed) break;
   }
   if ( !isClosed ) Print(" ", ticket, "  , :", GetLastError());
   return ( isClosed );
}

void close_all( int type_1 = -1,int type_2 = -1, int bars = 0 )
{
   int i;
   bool flag = false;
   if ( bars != 0 )flag = true;
   for( i = OrdersTotal() - 1; i >= 0; i-- )
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if( OrderMagicNumber() == ID && ((OrderType() == type_1 || OrderType() == type_2) || (type_1 == -1 && type_2 == -1)) && !flag )close(OrderTicket());   
      if( OrderMagicNumber() == ID && ((OrderType() == type_1 || OrderType() == type_2) || (type_1 == -1 && type_2 == -1)) && flag && (iBarShift(OrderSymbol(),Period(),OrderOpenTime()) - bars) >= 0 )close(OrderTicket());
      
   }   
}